{% extends "templates/spawn.html" %}

{% block heading %}
    <div class="container">
    	<div class="row justify-content-center">
	    <div class="row text-center col-sm-offset-2 col-sm-8 alert alert-info">
	      For information on JupyterHub usage and what software is
	      available, see the wiki page: 
	      <a href="https://wiki.maxiv.lu.se/index.php/SciSW:JupyterHub_on_HPC_Clusters_Usage"
		target="_blank"> JupyterHub HPC Usage</a>
	    </div>

    <div class="row text-center col-sm-offset-2 col-sm-8">
        <h1>MAX IV JupyterHub HPC</h1>
    </div>
    	</div>
    </div>

{% endblock %}

{% block footer %}

    <script>

        // Set the colors of the options in the node selection menu
        function setMenuColors(response){

            // console.log("hello setMenuColors()");
            var optionElements = document.getElementsByTagName("option"),
                value, rowStyle, optionColor,
                sinfo = response.sinfo,
                menuColors = response.menu,
                select = document.getElementsByTagName('select')[0];

            // Loop over menu options
            for (i = 0; i < optionElements.length; i += 1) {

                value = optionElements[i].getAttribute("value");
                // console.log("option:", value);
                optionColor = menuColors[value];
                // console.log("optionColor:", optionColor);
                rowStyle = "color:" + optionColor + ";";

                // Set the option color
                optionElements[i].style = rowStyle;

                // Disable options that can't be used
                if (rowStyle.includes("red")) {
                    optionElements[i].disabled = true;
                } else {
                    optionElements[i].disabled = false;
                }
            }

            // Set the initial color of the selected option (the first one)
            select.style = "color:" +
                select.options[select.selectedIndex].style.color + ";";

            // Set the selected option color when a new option is selected
            select.onchange = function () {
                // console.log("set style");
                // console.log(this.selectedIndex);
                // console.log(this.options[this.selectedIndex].style.color);

                var selectedColorStyle = "color:" +
                    this.options[this.selectedIndex].style.color + ";";

                select.style = selectedColorStyle;
            }

        }


        // Create and fill table containing sinfo output
        function createTable(response){
            // console.debug(response);

            var table_data_container = document.getElementById('sinfoBody'),
                frag = document.createDocumentFragment(),
                i, key, row, col, rowStyle,
                sinfo = response.sinfo,
                header = response.header,
                datetime = response.datetime;

            // console.log(header)
            // console.log(datetime)

            // Set the datetime
            timeDisplay = document.getElementById('myspan');
            timeDisplay.textContent = datetime;

            // Remove current table body and contents, create new one
            table_data_container.remove();
            table_data_container = document.createElement('tbody');
            table_data_container.value = 'sinfoBody';
            table_data_container.setAttribute("id", "sinfoBody");
            table_element = document.getElementById('sinfoTable');
            table_element.appendChild(table_data_container);

            // Loop over each item in the output, which corresponds to
            // the rows in sinfo output
            for (i = 0; i < sinfo.length; i += 1) {
                // console.log(sinfo[i]);

                // Ignore BioMax nodes
                if (sinfo[i].PARTITION === "bio" ||
                    sinfo[i].PARTITION === "bio-sf") {
                    continue;
                }

                // Set font color based on availability of nodes
                rowStyle = "color:" + sinfo[i].COLOR + ";";
                if (sinfo[i].COLOR !== "black") {
                    rowStyle += "font-weight:bold;";
                }

                // Create the row, add information into columns
                row = document.createElement('tr');
                for (key in sinfo[i]) {
                    // console.log(key)

                    // Check that item has expected key, ignore TIMELIMIT
                    if (header.includes(key) && key !== "TIMELIMIT") {
                        col = document.createElement('td');
                        col.style = "padding: 2px;";
                        col.textContent = sinfo[i][key];
                        row.appendChild(col);
                    }
                }
                row.style = rowStyle;
                frag.appendChild(row);
            }
            table_data_container.appendChild(frag);
        }


        // Get the sinfo data from a json file
        function fetchdata(){

            $.ajax({
                // Grab the output from hub_scripts/sinfo.py, which is run as
                // a service by JupyterHub - see c.JupyterHub.services in
                // jupyterhub_config.py
                // url: '/sinfo/sinfo_dev.json',
                url: '/sinfo/sinfo.json',
                type: "GET",
                success: function (response) {
                    createTable(response);
                    setMenuColors(response);
                },

                error: function (x, status, error) {
                    console.log("Error: " + error);
                }
            });

        }


        // When the html document is loaded, get the sinfo output, then
        // continually fetch it every 15 seconds - the file itself is updated
        // every 30 seconds
        $(document).ready(function(){
            fetchdata();
            setInterval(fetchdata, 15000);
        });

    </script>

    <!-- Initially empty table into which sinfo output will be placed -->
    <div class="container">
    	<div class="row justify-content-center">
    	    <div class="row col-sm-offset-3 col-sm-7">
    	        <div>
    	            <h3>Cluster node availability (sinfo): </h3>
    	            <span id="myspan"> ---- </span> (updates every 30 sec.)
    	        </div>

    	        <table id="sinfoTable">
    	            <thead>
    	                <tr>
    	                    <th style="padding: 2px;">PARTITION </th>
    	                    <th style="padding: 2px;">AVAIL </th>
    	                    <th style="padding: 2px;">NODES </th>
    	                    <th style="padding: 2px;">STATE </th>
    	                    <th style="padding: 2px;">NODELIST </th>
    	                </tr>
    	            </thead>
    	            <tbody id="sinfoBody"> </tbody>
    	        </table>
    	    </div>
    	</div>
    </div>

{% endblock %}
